> For the complete documentation index, see [llms.txt](https://docs.acecentre.org.uk/products/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.acecentre.org.uk/products/aac-speak-helper-tool/developer-notes.md).

# Developer Notes

* It works on Python 3.10 or 3.11. The dependencies aren't well covered on all other versions (and there are a lot!)
* We use a GitHub action to build the application (see workflow [here](https://github.com/AceCentre/TranslateAndTTS/blob/main/.github/workflows/windows-build-release.yml).)

## Building the Application

### Development Testing

```powershell
# Test the server
uv run python AACSpeakHelperServer.py

# Test the client (in another terminal)
uv run python client.py

# Test CLI configuration tool
uv run python cli_config_creator.py
```

### Building for Windows

```powershell
# Use the automated build script
.\build_executable.bat

# Or build manually:
# Build server
uv run python -m PyInstaller AACSpeakHelperServer.py --noupx --onedir --noconsole --name "AACSpeakHelperServer" -i .\assets\translate.ico --clean

# Build client
uv run python -m PyInstaller client.py --noupx --console --onedir --clean -i .\assets\translate.ico

# Build CLI configuration tool
uv run python -m PyInstaller cli_config_creator.py --noupx --console --name "Configure AACSpeakHelper CLI" --onedir --clean -i .\assets\configure.ico

# Note: GUI configuration tool is excluded from builds due to reliability issues

# Build installer (requires Inno Setup 6)
& "C:\Program Files (x86)\Inno Setup 6\ISCC.exe" .\buildscript.iss
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.acecentre.org.uk/products/aac-speak-helper-tool/developer-notes.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
